#include <cstdio>
#include <cstring>
#include <cstdlib>
#include <windows.h>

int
main(int argc, char **argv)
{
  if(argc != 2)
  {
    puts("usage: totaldump <pid>");
    return 1;
  }

  DWORD Pid;
  if(sscanf(argv[1], "%i", (unsigned int*)&Pid) != 1)
  {
    puts("Pid has to be in hex (0x1234) or dec (1234) form");
    return 2;
  }

  char DumpName[256];
  sprintf(DumpName, "pdump_%u.bin", (unsigned int)Pid);

  FILE *f;

  f = fopen(DumpName, "wb");
  if(!f)
  {
    puts("Could not open dump file!");
    return 4;
  }

  HANDLE Proc = OpenProcess(PROCESS_VM_READ, FALSE, Pid);
  if(Proc == NULL)
  {
    puts("Opening process failed!");
    fclose(f);
    return 3;
  }
  puts("Opening successful!");

  DWORD i, Accessed = 0, Total = 0;
  SIZE_T DataRead;
  for(i = 0; i < 0x80000000; i+= 0x1000, Total++)
  {
    static unsigned char Data[0x1000];
    if(Total % 256 == 0)
      printf("Accessing page %.8x... (Accessed pages / Total Pages: %i / %i)\r", i, Accessed, Total);

    memset(Data, 0, sizeof(Data));
    DataRead = 0;
    if(ReadProcessMemory(Proc, (PVOID)i, Data, sizeof(Data), &DataRead) != 0 && DataRead > 0)
    {
      fwrite(Data, 1, sizeof(Data), f);
      Accessed++;
    }
  }

  fclose(f);
  CloseHandle(Proc);
  printf("\nDone!\n");
 

  return 0;
}

