#pragma once
#include <windows.h>
#include <winnt.h>
#include <vector>
using namespace std;

class PESection
{
  public:
    IMAGE_SECTION_HEADER Header;
    BYTE *Data;

    PESection();
    ~PESection();
};

class PEImportFunc
{
  public:
    unsigned short Hint;
    char FuncName[256];

    PEImportFunc();
};

class PEImport
{
  public:
    DWORD FirstThunk;
    char  FileName[256];
    vector<PEImportFunc *> FuncList;

    PEImport();
    ~PEImport();
};

class PE
{
  private:
    void PadTo(FILE *f, size_t addr);
    void AlignTo(FILE *f, size_t addr);

  public:
    IMAGE_DOS_HEADER DosHeader;
    IMAGE_NT_HEADERS NtHeaders;
    vector<PESection *> Sections;
    vector<PEImport  *> Imports;

    PE();
    ~PE();

    bool Load(const char *name);
    bool Dump(const char *name);
    WORD RVAtoSection(DWORD rva);
    BYTE *RVAtoPtr(DWORD rva);
};

