#include <windows.h>
#include <stdio.h>
#include "PE.h"

int
main(int argc, char **argv)
{
  PE file;

  puts("TraceDump (by gynvael.coldwind//vx)");
  puts("Warning: this program launches the unpacked app!");

  if(argc != 2)
  {
    printf("usage: TraceDump <file.exe>\n");
    return 1;
  }

  // Load the PE and save the EntrySec
  file.Load(argv[1]);
  
  DWORD EntryPointVA = file.NtHeaders.OptionalHeader.AddressOfEntryPoint + file.NtHeaders.OptionalHeader.ImageBase;
  WORD EntrySec = file.RVAtoSection(file.NtHeaders.OptionalHeader.AddressOfEntryPoint);
  if(EntrySec == 0)
    puts("This hack might not work.");

  printf("Entry section: %i\n", EntrySec);

  // Launch the app in single step mode and catch any entry to any other section
  DWORD ImageFrom = file.NtHeaders.OptionalHeader.ImageBase;
  DWORD ImageTo   = ImageFrom + file.NtHeaders.OptionalHeader.SizeOfImage;

  puts("Launching the application...");
  STARTUPINFO si;
  PROCESS_INFORMATION pi;
  ZeroMemory(&si, sizeof(si));
  si.cb = sizeof(si);
  ZeroMemory(&pi, sizeof(pi));

  if(!CreateProcess(NULL, argv[1], NULL, NULL, FALSE, DEBUG_PROCESS, NULL, NULL, &si, &pi))
  {
    puts("CreateProcess() failed");
    return 1;
  }

  DEBUG_EVENT DebugEv;
  bool EndLoop = false;  
  DWORD OriginalEntryPoint = 0;

  ContinueDebugEvent(pi.dwProcessId, pi.dwThreadId, DBG_CONTINUE); 
  for(;!EndLoop;) 
  {
    WaitForDebugEvent(&DebugEv, INFINITE); 

    CONTEXT cont;
    cont.ContextFlags = CONTEXT_CONTROL;
    GetThreadContext(pi.hThread, &cont);
 
    // Process the debugging event code. 
 
    static BYTE OrgEntryByte;

    switch (DebugEv.dwDebugEventCode) 
    { 
        case EXCEPTION_DEBUG_EVENT: 
            switch (DebugEv.u.Exception.ExceptionRecord.ExceptionCode) 
            { 
                case EXCEPTION_ACCESS_VIOLATION: 
                puts("EXCEPTION_ACCESS_VIOLATION");
	        EndLoop = true;
		break;
         
                case EXCEPTION_BREAKPOINT: 
		if(cont.Eip != EntryPointVA + 1)
		{
		  puts("Setting break point");
		  ReadProcessMemory(pi.hProcess, (LPVOID)EntryPointVA, &OrgEntryByte, 1, NULL);
		  VirtualProtectEx(pi.hProcess, (LPVOID)EntryPointVA, 1, PAGE_EXECUTE_READWRITE, NULL);
		  WriteProcessMemory(pi.hProcess, (LPVOID)EntryPointVA, "\xCC", 1, NULL);		  
		}
		else
		{
                  puts("Entering trace mode");
                  WriteProcessMemory(pi.hProcess, (LPVOID)EntryPointVA, &OrgEntryByte, 1, NULL);
		  cont.EFlags |= 0x100; // TF
		  cont.Eip = EntryPointVA;
                  SetThreadContext(pi.hThread, &cont);
		}            
		break;
                
		case EXCEPTION_SINGLE_STEP: 
                if(cont.Eip >= ImageFrom && cont.Eip < ImageTo &&
                   file.RVAtoSection(cont.Eip - file.NtHeaders.OptionalHeader.ImageBase) != EntrySec)
                {
                  // this is it
		  EndLoop = true;
		  printf("OEP: 0x%.x\n", cont.Eip);
		  OriginalEntryPoint = cont.Eip;
		  break;
    
                }
		cont.EFlags |= 0x100; // TF
                SetThreadContext(pi.hThread, &cont);
                break;
            } 
	    break;
 
        case EXIT_THREAD_DEBUG_EVENT: 
        case EXIT_PROCESS_DEBUG_EVENT: 
	    EndLoop = true;
	    break;
    } 
 
    ContinueDebugEvent(DebugEv.dwProcessId, DebugEv.dwThreadId, DBG_CONTINUE); 
  }
 
  if(OriginalEntryPoint)
  {
    puts("Saving dumped.exe");
    ReadProcessMemory(pi.hProcess, (LPVOID)(file.Sections[0]->Header.VirtualAddress + file.NtHeaders.OptionalHeader.ImageBase),
	              file.Sections[0]->Data, file.Sections[0]->Header.SizeOfRawData, NULL);
    file.NtHeaders.OptionalHeader.AddressOfEntryPoint = OriginalEntryPoint - file.NtHeaders.OptionalHeader.ImageBase;
    file.Dump("dumped.exe");

  } 

  puts("End");
  TerminateProcess(pi.hProcess, 0);
  CloseHandle(pi.hProcess);
  CloseHandle(pi.hThread);

  return 0;
}

